com.orsoncharts.data

## Interface Values3D<T>

- Type Parameters:
    `T` - The value type (normally a numeric type).
  All Known Subinterfaces:
    CategoryDataset3D<S,R,C>, KeyedValues3D<S,R,C,T>
  All Known Implementing Classes:
    DefaultKeyedValues3D, StandardCategoryDataset3D

      public interface Values3D<T>

  A generic representation of a three dimensional grid (cube) of data values. We refer to the indices in the three dimensions as the `seriesIndex`, the `rowIndex` and the `columnIndex` (to match the downstream use of this data structure to represent data values in a three dimensional plot).
  See Also:
    `KeyedValues3D`

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `int` | `getColumnCount()` Returns the number of items in the z-dimension.
    `double` | `getDoubleValue(int seriesIndex, int rowIndex, int columnIndex)` Returns the data item at the specified position as a double primitive.
    `int` | `getRowCount()` Returns the number of items in the y-dimension.
    `int` | `getSeriesCount()` Returns the number of items in the x-dimension.
    `T` | `getValue(int seriesIndex, int rowIndex, int columnIndex)` Returns the data item at the specified position.

- - ### Method Detail

    - #### getSeriesCount

          int getSeriesCount()

      Returns the number of items in the x-dimension.
      Returns:
        The number of items in the x-dimension.

    - #### getRowCount

          int getRowCount()

      Returns the number of items in the y-dimension.
      Returns:
        The number of items in the y-dimension.

    - #### getColumnCount

          int getColumnCount()

      Returns the number of items in the z-dimension.
      Returns:
        The number of items in the z-dimension.

    - #### getValue

          T getValue(int seriesIndex,
                     int rowIndex,
                     int columnIndex)

      Returns the data item at the specified position.
      Parameters:
        `seriesIndex` - the series-index.
        `rowIndex` - the row-index.
        `columnIndex` - the column-index.
      Returns:
        The data value (possibly `null`).

    - #### getDoubleValue

          double getDoubleValue(int seriesIndex,
                                int rowIndex,
                                int columnIndex)

      Returns the data item at the specified position as a double primitive. Where the `getValue(int, int, int)` method returns `null`, this method returns `Double.NaN`.
      Parameters:
        `seriesIndex` - the series index.
        `rowIndex` - the row index.
        `columnIndex` - the column index.
      Returns:
        The data value.